import subprocess
from tester import Tester
from presenter import Presenter
from tester import get_sy_testcases
from pretty_print import Print_C

thu_compiler = "build/bin/thu_compiler "
ustc_compiler = "build/bin/ustc_compiler "
ustc_compiler_no_vec = "build/bin/ustc_compiler_no_vec "
compiler = "java -classpath src:lib/antlr-4.10.1.jar Compiler "

clang_llvm_scheme = {"scheme": "clang_llvm",
                     "frontend_instr": "clang -x c -c -Ofast --target=arm-none-eabi -mcpu=cortex-a72 -mfpu=neon -mfloat-abi=hard -S -emit-llvm -include {header} {sy} -o {ir}",
                     "emit_llvm_ir": True}

compiler_scheme = {"scheme": "compiler",
                "frontend_instr": compiler + "-S {sy} -o {ir}",
                "emit_llvm_ir": True}

all_schemes = [clang_llvm_scheme, compiler_scheme] # gcc_gcc_scheme, ustc_ustc_scheme, ustc_ustc_no_vec_scheme]
testers = []

Print_C.print_header("[Removing old data...]\n\n")
subprocess.run("rm -rf build/test_results/".split())
subprocess.run("rm -rf build/output/".split())
subprocess.run("rm -rf build/log/compile_log".split())
subprocess.run("rm -rf build/log/run_log".split())
subprocess.run("rm -rf build/log/test_result.log".split())

for scheme in all_schemes:
    tester = Tester(scheme, is_trivial=True)
    testers.append(tester)
    tester.test()

# Tester(ustc_llvm_scheme).test_ir()

# presenter = Presenter(schemes=[scheme["scheme"] for scheme in all_schemes], testcases=get_sy_testcases())
# presenter.present_all_testcases()
