package ir;

import ir.value.Function;
import ir.value.NameSpace;
import ir.value.Value;
import util.MyList;
import util.MyNode;
/*
    编译模块，保存全局变量和函数信息
 */
import java.util.ArrayList;

public class MyModule {
    public MyList<Function> getFunctions() {
        return functions;
    }

    MyList<Function> functions;
    ArrayList<Value> globals;

    public MyModule() {
        functions = new MyList<>();
        globals = new ArrayList<>();
    }

    public ArrayList<Value> getGlobals() {
        return globals;
    }

    public void addFunc(Function function) {
        functions.addLast(function.getNode());
    }

    public void addVar(Value value) {
        for (int i = 0; i < globals.size(); i++) {
            if (globals.get(i).getName().equals(value.getName())) {
                globals.set(i, value);
                return;
            }
        }
        globals.add(value);
    }

    public void setName() {
        functions.forEach( function -> {
            NameSpace nameSpace = new NameSpace();
            function.getValue().getParams().forEach(
                    param-> {
                        param.setName(nameSpace.getName());
                    }
            );
            function.getValue().getList().forEach(
                    bb -> {
                        bb.getValue().setName(nameSpace.getBlockName());
                        bb.getValue().getList().forEach(
                                instrNode ->{
                                    if (instrNode.getValue().CanNamed()) {
                                        instrNode.getValue().setName(nameSpace.getName());
                                    }
                                }
                        );
                    }
            );
                }
        );
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("target triple = \"armv8-none-unknown-eabihf\"\n\n");
        for (Value global : globals) {
            sb.append(global).append("\n");
        }
        for (MyNode<Function> function : functions) {
            sb.append(function.getValue()).append("\n");
        }
        return sb.toString();
    }
}
