package ir.instruction;

import ir.type.PointerSysYType;
import ir.type.SysYType;
import ir.value.NameSpace;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class AllocaInstr extends Instr {
    private int size;
    public AllocaInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public AllocaInstr(SysYType type, int size) {
        super(type, "");
        this.size = size;
    }
    public AllocaInstr(SysYType type) {
        super(type, "");
    }

    @Override
    public String toString() {
        return getName() + " = " + "alloca " + ((PointerSysYType)getType()).getParam();
    }
}
