package ir.instruction;

import ir.type.VoidSysYType;
import ir.value.BasicBlock;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class BrInstr extends Instr {

    public final static int SINGLE = 0;
    public final static int DOUBLE = 1;
    public BrInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    private int type;


    public BasicBlock getBasicBlock1() {
        return basicBlock1;
    }

    public BasicBlock getBasicBlock2() {
        return basicBlock2;
    }

    private Value conv;

    private BasicBlock basicBlock1;
    private BasicBlock basicBlock2;

    public BrInstr(Value conv, BasicBlock basicBlock1, BasicBlock basicBlock2) {
        super(VoidSysYType.construct(), "");
        this.basicBlock1 = basicBlock1;
        this.basicBlock2 = basicBlock2;
        this.type = DOUBLE;
        this.conv = conv;
    }

    public BrInstr(BasicBlock basicBlock) {
        super(VoidSysYType.construct(), "");
        this.basicBlock1 = basicBlock;
        this.type = SINGLE;
    }

    @Override
    public boolean CanNamed() {
        return false;
    }

    @Override
    public String toString() {
        if (type == SINGLE) {
            return "br label " + basicBlock1.getName();    //条件跳转
        } else {
            return "br i1 " + conv.getName() + ", label " + basicBlock1.getName() + ", label " + basicBlock2.getName();         //无条件跳转
        }
    }
}
