package ir.instruction;

import ir.type.IntSysYType;
import ir.type.PointerSysYType;
import ir.type.SysYType;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class CastInstr extends Instr{

    static int SITOFP = 0;
    static int FPTOSI = 1;
    private Value source;
    private SysYType target;
    private int castType;
    public CastInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public CastInstr(Value source, SysYType target) {
        super(target, "");
        this.source = source;
        this.target = target;
        if (target.equals(IntSysYType.construct())) {
            castType = FPTOSI;
        } else {
            castType = SITOFP;
        }
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getName()).append(" = ");
        if (castType == FPTOSI) {
            sb.append("fptosi");
        } else {
            sb.append("sitofp");
        }
        sb.append(" ").append(source.getType()).append(" ");
        sb.append(source.getName()).append(" to ").append(getType());

        return sb.toString();
    }
}
