package ir.instruction;

import ir.type.IntSysYType;
import ir.type.PointerSysYType;
import ir.type.SysYType;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class GetElemPtrInstr extends Instr {
    private Value base;     //基地址指针
    private ArrayList<Value> indexs;    //索引表
    //private ArrayList<Value> indexs;


    public GetElemPtrInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public GetElemPtrInstr(Value base, ArrayList<Value> indexs, SysYType type) {
        super(type, "");
        this.base = base;
        this.indexs = indexs;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getName()).append(" = getelementptr ");
        sb.append(((PointerSysYType)base.getType()).getParam()).append(", ");
        sb.append(base.getType()).append(" ").append(base.getName()).append(", ");
        for (int i = 0; i < indexs.size(); i++) {
            sb.append(IntSysYType.construct()).append(" ").append(indexs.get(i).getName());
            if (i != indexs.size() - 1) {
                sb.append(", ");
            }
        }
        //sb.append(", align 4");
        return sb.toString();
    }
}
