package ir.instruction;

import ir.type.SysYType;
import ir.value.User;
import ir.value.Value;
import util.MyNode;

import java.util.ArrayList;

public class Instr extends User {
    private SysYType type;
    private MyNode<Instr> node;

    public Instr(ArrayList<Value> uses) {
        super(new ArrayList<>(), uses);
    }

    public Instr(ArrayList<User> users,ArrayList<Value> uses) {
        super(users, uses);
    }

    public Instr(SysYType type, String name) {
        super(type, name);
        this.type = type;
        node = new MyNode<>(null, this, null);
    }

    public boolean CanNamed() { return true; }
    //插入当前指令之前
    public void insertBefore(Instr other) {
        node.insertBefore(other.getNode());
    }

    //插入到当前指令之后
    public void insertAfter(Instr other) {
        node.insertAfter(other.getNode());
    }

    public MyNode<Instr> getNode() {
        return node;
    }
}
