package ir.instruction;

import ir.type.PointerSysYType;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class LoadInstr extends Instr {
    private Value ptr;

    public LoadInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public LoadInstr(Value ptr) {
        super(((PointerSysYType)ptr.getType()).getParam(), "");
        this.ptr = ptr;
    }

    @Override
    public String toString() {
        return  getName() + " = load " +
                ((PointerSysYType) ptr.getType()).getParam() + ", "
                + ptr.getType() + " " + ptr.getName();
    }
}
