package ir.instruction;

import ir.type.SysYType;
import ir.value.BasicBlock;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;
import java.util.HashMap;

public class PhiInstr extends Instr {
    private HashMap<BasicBlock, Value> values;   //指令块和value的键值对

    public PhiInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public PhiInstr(SysYType type,HashMap<BasicBlock, Value> values) {
        super(type, "");
        this.values = values;
    }

    @Override
    public boolean CanNamed() {
        return false;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("phi ").append(getType()).append(" ");
        for (BasicBlock basicBlock : values.keySet()) {
            sb.append("[ ");
            sb.append(basicBlock.getName());
            sb.append(", ");
            sb.append(values.get(basicBlock).getName());
            sb.append(" ], ");
        }
        sb.delete(sb.length() - 2, sb.length());
        return sb.toString();
    }
}
