package ir.instruction;

import ir.type.SysYType;
import ir.type.VoidSysYType;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class RetInstr extends Instr {
    public RetInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public RetInstr(SysYType type, String name) {
        super(type, name);
    }

    @Override
    public boolean CanNamed() {
        return false;
    }

    @Override
    public String toString() {
        if (getType().equals(VoidSysYType.construct())) {
            return "ret " + getType();               //返回void
        } else {
            return "ret "  + getType() + " " + uses.get(0).getName();             //返回一个value
        }
    }
}
