package ir.instruction;

import ir.type.PointerSysYType;
import ir.value.User;
import ir.value.Value;

import java.util.ArrayList;

public class StoreInstr extends Instr {
    private Value ptr;
    private Value target;
    public StoreInstr(ArrayList<User> users, ArrayList<Value> uses) {
        super(users, uses);
    }

    public StoreInstr(Value target, Value ptr) {
        super(((PointerSysYType)ptr.getType()).getParam(), "");
        this.ptr = ptr;
        this.target = target;
    }

    @Override
    public boolean CanNamed() {
        return false;
    }

    @Override
    public String toString() {
        return "store " + target.getType() +  " " +
                target.getName() + ", " + ptr.getType()
                + " " + ptr.getName();
    }
}
