package ir.type;

import java.util.Objects;

/**
 * 常量类型
 */
public class ConstSysYType implements SysYType{
    private final SysYType param;

    public ConstSysYType(SysYType param) {
        this.param = param;
    }

    public static ConstSysYType construct(SysYType inner) {
        return new ConstSysYType(inner);
    }
    public SysYType getParam() {
        return param;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ConstSysYType that = (ConstSysYType) o;
        return param.equals(that.param);
    }

    @Override
    public int hashCode() {
        return Objects.hash(param);
    }

    @Override
    public String toString() {
        return param.toString();
    }
}
