package ir.type;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 用户函数类型
 */
public class FunctionSysYType implements SysYType{
    private final ArrayList<SysYType> params;
    private final SysYType ret;

    public FunctionSysYType(ArrayList<SysYType> params, SysYType ret) {
        this.params = params;
        this.ret = ret;
    }

    public FunctionSysYType(SysYType ret, SysYType... params) {
        this.params = (ArrayList<SysYType>) List.of(params);
        this.ret = ret;
    }

    public static FunctionSysYType construct(SysYType ret, SysYType... params) {
        return new FunctionSysYType((ArrayList<SysYType>) List.of(params), ret);
    }

    public ArrayList<SysYType> getParams() {
        return params;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        FunctionSysYType that = (FunctionSysYType) o;
        return params.equals(that.params) && ret.equals(that.ret);
    }

    @Override
    public int hashCode() {
        return Objects.hash(params, ret);
    }

    public SysYType getRet() {
        return ret;
    }

    @Override
    public String toString() {
        return ret.toString();
    }
}
