package ir.type;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 标准库定义的函数类型
 */
public class NativeFunctionSysYType implements SysYType{
    private final ArrayList<SysYType> params;
    private final SysYType ret;

    public NativeFunctionSysYType(ArrayList<SysYType> params, SysYType ret) {
        this.params = params;
        this.ret = ret;
    }

    public NativeFunctionSysYType(SysYType ret, SysYType... params) {
        this.params = (ArrayList<SysYType>) List.of(params);
        this.ret = ret;
    }
    public static NativeFunctionSysYType construct(SysYType ret, SysYType... params) {
        return new NativeFunctionSysYType((ArrayList<SysYType>) List.of(params), ret);
    }
    public ArrayList<SysYType> getParams() {
        return params;
    }

    public SysYType getRet() {
        return ret;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        NativeFunctionSysYType that = (NativeFunctionSysYType) o;
        return params.equals(that.params) && ret.equals(that.ret);
    }

    @Override
    public int hashCode() {
        return Objects.hash(params, ret);
    }
}
