package ir.value;

import ir.type.SysYType;

import java.util.ArrayList;

public class Value {
    protected ArrayList<User> users; // 这个值的使用者
    private SysYType type;
    private String name;
    public Value(ArrayList<User> users, SysYType type) {
        this.users = users;
        this.type = type;
    }

    public String getName() {
        return name;
    }

    public Value(SysYType type, String name) {
        this.type = type;
        this.name = name;
        this.users = new ArrayList<>();
    }

    public Value(SysYType type) {
        this.type = type;
        this.users = new ArrayList<>();
    }

    public void addUser(User user) {
        users.add(user);
    }

    public Value(ArrayList<User> users) {
        this.users = users;
    }

    public SysYType getType() {
        return type;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setType(SysYType type) {
        this.type = type;
    }
}
