package treeir;

import ir.type.SysYType;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * FuncDef(Seq)
 * 函数声明
 */
public class FuncDef extends Node{
    private SysYType type;
    private final HashMap<String, SysYType> locals;

    public void setType(SysYType type) {
        this.type = type;
    }

    public ArrayList<String> getParameter() {
        return parameter;
    }

    private final HashMap<String, TreeValue> constants;
    private final ArrayList<String> parameter;

    private final String name;

    public FuncDef(ArrayList<Node> children, SysYType type, HashMap<String, SysYType> locals, HashMap<String, TreeValue> constants, Node parent, ArrayList<String> parameter, String name) {
        super(children, parent);
        this.type = type;
        this.locals = locals;
        this.constants = constants;
        this.parameter = parameter;
        this.name = name;
    }

    public FuncDef(Node parent, String name) {
        super(new ArrayList<>(),parent);
        this.name = name;
        this.type = null;
        this.locals = new HashMap<>();
        this.constants = new HashMap<>();
        this.parameter = new ArrayList<>();
    }
    public HashMap<String, SysYType> getLocals() {
        return locals;
    }

    public SysYType getType() {
        return type;
    }

    public HashMap<String, TreeValue> getConstants() {
        return constants;
    }

    public String getName() {
        return name;
    }

    @Override
    public TreeValue evaluate(Map<String, TreeValue> env) {
        return null;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("(define " + name + "\n\t(lambda (");
        for (var para:
             parameter) {
            sb.append(para).append(" ");
        }
        sb.append(")");
        sb.append("\n\t(");
        for (var child :
                children) {
            sb.append(child.toString());
        }
        sb.append("\t)\n)");
        return sb.toString();
    }
}
