package treeir;

import java.util.ArrayList;
import java.util.Map;

public class Index extends Node{
    public Index(ArrayList<Node> children, Node parent) {
        super(children, parent);
    }

    @Override
    public TreeValue evaluate(Map<String, TreeValue> env) {
        var idxObj = children.get(1).evaluate(env);
        var idx = 0;
        if (idxObj.discrimination == 0) {
            idx = idxObj.intVal;
        } else if(idxObj.discrimination == 1) {
            idx = (int)idxObj.floatVal;
        } else {
            assert false;
        }
        return children.get(0).evaluate(env).index(idx);
    }

    @Override
    public String toString() {
        return String.format("(Index %s %s)",
                children.get(0),
                children.get(1)
        );
    }
}
