package treeir;

import ir.type.ArraySysYType;
import ir.type.SysYType;

import java.util.ArrayList;
import java.util.Map;

/**
 * 为了方便处理，不使用嵌套表示数组，而使用连续内存。
 * 例如，int[2][2]{2,0,{3,3}} 表示为 [2,0,3,3]
 */
public class MyArray extends Node {
    // 这个type顶层不能有const
    private SysYType type;

    public SysYType getType() {
        return type;
    }

    public void setType(SysYType type) {
        this.type = type;
    }

    public MyArray(ArrayList<Node> children, Node parent) {
        super(children, parent);
    }

    @Override
    public TreeValue evaluate(Map<String, TreeValue> env) {
        ArrayList<TreeValue> ret = new ArrayList<>();
        for (var node :
                children) {
            ret.add(node.evaluate(env));
        }
        return new TreeValue(ret, (ArrayList<Integer>) ((ArraySysYType)type).getDims());
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("[");
        for (var child :
                children) {
            sb.append(child).append(" ");
        }
        sb.append("]");
        return sb.toString();
    }
}
