package treeir;

import java.util.ArrayList;
import java.util.Map;

/**
 * 树形式的HIR，（好像有其他语言用树作为HIR，但是好像主要是做类型推导之类）
 * 不知道对优化有没有帮助
 * ANTLR生成的树有些复杂，而HIR对生成LLVM IR更友好
 */
public abstract class Node {
    protected final ArrayList<Node> children;

    public void setParent(Node parent) {
        this.parent = parent;
    }

    protected Node parent;

    protected Node(ArrayList<Node> children, Node parent) {
        this.children = children;
        this.parent = parent;
    }

    public Node getParent() {
        return parent;
    }

    public ArrayList<Node> getChildren() {
        return children;
    }
    public void addChildLast(Node node) {
        children.add(node);
    }

    public Node getLastChild() {
        return children.get(children.size() - 1);
    }

    public Node popLastChild() {
        var ret = children.get(children.size() - 1);
        children.remove(children.size() - 1);
        return ret;
    }

    /**
     * 计算子树，用于对常量表达式编译期求值
     * @param env 常量表
     * @return TreeValue是一个“值” 包括float，int，array
     */
    public abstract TreeValue evaluate(Map<String, TreeValue> env);
}
