package treeir;

import ir.type.SysYType;
import ir.value.InitVal;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * Root(FuncDef, FuncDef, ...)
 */
public class Root extends Node{

    public HashMap<String, SysYType> getGlobals() {
        return globals;
    }

    public HashMap<String, InitVal> getConstants() {
        return constants;
    }

    private final HashMap<String, SysYType> globals;
    private final HashMap<String, InitVal> constants;//unused

    private final HashMap<String, SysYType> functions;

    public Root() {
        super(new ArrayList<>(), null);
        this.functions = new HashMap<>();
        this.globals = new HashMap<>();
        this.constants = new HashMap<>();
    }

    public HashMap<String, SysYType> getFunctions() {
        return functions;
    }

    @Override
    public TreeValue evaluate(Map<String, TreeValue> env) {
        return null;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder("Program Begin\n");
        for (var child :
                children) {
            sb.append(child).append("\n");
        }
        return sb.toString();
    }
}
