package util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Spliterator;
import java.util.function.Consumer;

//封装自己的链表，方便插入
public class MyList<E> implements Iterable<MyNode<E>> {
    private int size = 0;
    private MyNode<E> first;
    private MyNode<E> last;

    public List<E> toList() {
        var ret = new ArrayList<E>();
        for (var node :
                this) {
            ret.add(node.value);
        }
        return ret;
    }

    public int getSize() {
        return size;
    }

    public void addLast(MyNode<E> node) {
        if (last != null) {
            last.next = node;
        } else {
            last = node;
            first = node;
        }
        node.next = last;
        last = node;
        size++;
    }

    public void add(MyNode<E> node) {
        addLast(node);
    }

    public void addFirst(MyNode<E> node) {
        if (first != null) {
            first.prev = node;
        } else {
            last = node;
            first = node;
        }
        node.next = first;
        first = node;
        size++;
    }

    public MyNode<E> getFirst() {
        return first;
    }

    public MyNode<E> getLast() {
        return last;
    }

    class MyIterator implements Iterator<MyNode<E>> {
        private int index = 0;
        private MyNode<E> curent = first;

        @Override
        public void remove() {
            Iterator.super.remove();
        }

        @Override
        public void forEachRemaining(Consumer<? super MyNode<E>> action) {
            Iterator.super.forEachRemaining(action);
        }

        @Override
        public boolean hasNext() {
            return index != size;
        }

        @Override
        public MyNode<E> next() {
            MyNode<E> prev = curent;
            curent = curent.next;
            index++;
            return prev;
        }
    }


    @Override
    public Spliterator spliterator() {
        return Iterable.super.spliterator();
    }

    @Override
    public Iterator<MyNode<E>> iterator() {
        return new MyIterator();
    }
}
